#ifndef SOCKET_H_
#define SOCKET_H_

#include "MDM.h"

/** Socket file descriptor and select wrapper
  */
class Socket {
public:
    Socket() {
        _socket  = -1;
        _timeout = -1;
        _mdm     = NULL;
    }
    
    void set_blocking(bool blocking, unsigned int timeout=1) {
        _timeout = blocking ? (unsigned int) -1 /* blocking */ : timeout;
        if (_socket >= 0) {
            _mdm->socketSetBlocking(_socket, _timeout); 
        }
    }
    
    int close() {
        bool ret = false;
        if (_socket >= 0)
        {
            ret = _mdm->socketClose(_socket);
            _mdm->socketFree(_socket);
            _socket = -1;
        }
        return ret ? 0 : -1;
    }
    
    ~Socket() { close(); }
    
protected:
    int _socket;
    int _timeout;
    MDMParser* _mdm;
};


#endif /* SOCKET_H_ */
